#!/bin/bash
#move generated colors to a kde colorscheme

function apply_scheme() {
#  fly-wmfunc FLYWM_UPDATE_VAL WallPaper "$imagePath"
#  fly-admin-theme ColorScheme "$schemeUserPath"
#  echo "Applied color scheme   $schemeUserPath"
echo "$schemeUserPath"
}

if [ -z "$1" ]; then
  echo "No image file path, use with args: [-l|-d] pathToImage" >&2
  exit 1
fi

imagePath=
lightness=
lightnessru=
lightnessArg=
if [ $1 = "-l" ]; then
   lightnessArg="$1"
   lightness="light"
   lightnessru="светлая"
else
 if [ $1 = "-d" ]; then
   lightnessArg="$1"
   lightness="dark"
   lightnessru="темная"
 else
   imagePath="$1"
 fi
fi

if [ -z $lightness ]; then
  lightnessArg="-l"
  lightness="light"
  lightnessru="светлая"
else
  imagePath="$2"
fi

if [ ! -f "$imagePath" ]; then
  echo "No image file path exists $imagePath" >&2
  exit 1
fi

#rm -f ~/.config/kdeglobals
pkill fly-admin-theme

fname=$(basename "$imagePath")
schemeName="$fname-generated-$lightness"

schemeSysDir="/usr/share/color-schemes"
schemeUserDir="$HOME/.local/share/color-schemes"

schemeSysPath="$schemeSysDir/$schemeName.colors"
schemeUserPath="$schemeUserDir/$schemeName.colors"

reused=
if [ -f "$schemeUserPath" ]; then
  apply_scheme
  exit 0
else
  if [ -f "$schemeSysPath" ]; then
    apply_scheme
    exit 0
  fi
fi

#colors=$(convert "$imagePath" -resize 25% -colors 16 -unique-colors txt:- | grep -E -o "\#.{6}")
colors=$(convert  "$imagePath" -resize 25% -colors 16 -unique-colors txt:- | tail -n +2 | cut -f4 -d' ')

counter=0
for item in ${colors}; do
  if [ $counter = "0" ]; then
    background="$item"
    color0="$item"
  fi
  if [ $counter = "8" ]; then
    color1="$item"
    color9="$item"
  fi
  if [ $counter = "9" ]; then
    color2="$item"
    color10="$item"
  fi
  if [ $counter = "10" ]; then
    color3="$item"
    color11="$item"
  fi
  if [ $counter = "11" ]; then
    color4="$item"
   color12="$item"
  fi
  if [ $counter = "12" ]; then
    color5="$item"
    color13="$item"
  fi
  if [ $counter = "13" ]; then
    color6="$item"
    color14="$item"
  fi
  if [ $counter = "14" ]; then
    color7="$item"
    color15="$item"
  fi
  if [ $counter = "15" ]; then
    color8="$item"
    foreground="$item"
  fi
  #echo src palette item $item >&2
  let counter++
done
if [ $counter -lt 16 ]; then
 echo "failed to get 16 colors palette from $imagePath" >&2
 exit 1
fi

colors=$(echo "$color0
$color1
$color2
$color3
$color4
$color5
$color6
$color7
$color8
$color9
$color10
$color11
$color12
$color13
$color14
$color15
" | /usr/bin/fly-adjust-palette $lightnessArg)


counter=0
for item in ${colors}; do
#  echo adjusted palette item is $item
  declare color$counter="$item"
  if [ $counter = "0" ];  then background="$item"; fi
  if [ $counter = "15" ]; then foreground="$item"; fi
  let counter++
done

#echo fg=$foreground bg=$background c0=$color0 c7=$color7 c8=$color8 c15=$color15

echo "
[ColorEffects:Disabled]
Color=$background
ColorAmount=0
ColorEffect=3
ContrastAmount=0.55
ContrastEffect=1
IntensityAmount=-1
IntensityEffect=0

[ColorEffects:Inactive]
ChangeSelectionColor=true
Color=$background
ColorAmount=0
ColorEffect=0
ContrastAmount=0
ContrastEffect=0
Enable=false
IntensityAmount=-1
IntensityEffect=0

[Colors:Button]
BackgroundAlternate=$color16
BackgroundNormal=$background
DecorationFocus=$color3
DecorationHover=$color3
ForegroundActive=$color3
ForegroundInactive=$color0
ForegroundLink=$color3
ForegroundNegative=$color2
ForegroundNeutral=$color6
ForegroundNormal=$foreground
ForegroundPositive=$color5
ForegroundVisited=$color0

[Colors:Selection]
BackgroundAlternate=$color3
BackgroundNormal=$color3
DecorationFocus=$color3
DecorationHover=$color3
ForegroundActive=$background
ForegroundInactive=$color0
ForegroundLink=$color3
ForegroundNegative=$color2
ForegroundNeutral=$color6
ForegroundNormal=$foreground
ForegroundPositive=$color5
ForegroundVisited=$color0

[Colors:Tooltip]
BackgroundAlternate=$color16
BackgroundNormal=$background
DecorationFocus=$color3
DecorationHover=$color3
ForegroundActive=$color3
ForegroundInactive=$color0
ForegroundLink=$color3
ForegroundNegative=$color2
ForegroundNeutral=$color6
ForegroundNormal=$foreground
ForegroundPositive=$color5
ForegroundVisited=$color0

[Colors:View]
BackgroundAlternate=$color16
BackgroundNormal=$background
DecorationFocus=$color3
DecorationHover=$color3
ForegroundActive=$color3
ForegroundInactive=$color0
ForegroundLink=$color3
ForegroundNegative=$color2
ForegroundNeutral=$color6
ForegroundNormal=$foreground
ForegroundPositive=$color5
ForegroundVisited=$color0

[Colors:Window]
BackgroundAlternate=$color16
BackgroundNormal=$background
DecorationFocus=$color3
DecorationHover=$color3
ForegroundActive=$color3
ForegroundInactive=$color0
ForegroundLink=$color3
ForegroundNegative=$color2
ForegroundNeutral=$color6
ForegroundNormal=$foreground
ForegroundPositive=$color5
ForegroundVisited=$color0

[Colors:Header]
BackgroundAlternate=$color16
BackgroundNormal=$background
DecorationFocus=$color3
DecorationHover=$color3
ForegroundActive=$color3
ForegroundInactive=$color0
ForegroundLink=$color3
ForegroundNegative=$color2
ForegroundNeutral=$color6
ForegroundNormal=$foreground
ForegroundPositive=$color5
ForegroundVisited=$color0

[General]
ColorScheme=$fname-$lightness
Name=$lightness generated of $fname
Name[ru]=$lightnessru из $fname
shadeSortColumn=true

[KDE]
contrast=5

[WM]
activeBackground=$color3
activeBlend=$color3
activeForeground=$foreground
inactiveBackground=$color0
inactiveBlend=$color0
inactiveForeground=$color7" > "$schemeUserPath"

#kwriteconfig5 --file ~/.config/kdeglobals --group WM --key frame $color3 #these lines come from https://github.com/gikari/bismuth/blob/master/TWEAKS.md
#kwriteconfig5 --file ~/.config/kdeglobals --group WM --key inactiveFrame $color0 #they are used to change the color of the border around windows, useful if you use borders

apply_scheme
exit 0
