#!/bin/bash

SOUND_PATH="$1"
SOUND_PLAYER=""
SOUND_VOLUME=""
SAVED_VOLUME=""
#file to play
if [ -z "$1" ]; then
  echo "No sound argument, use full sound file path OR fly-wm sound parameter name for example ForceTrayMessageSound"
  exit 1
fi

if [ "$SOUND_PATH" = "empty" ]; then
  SOUND_PATH=""
else
  if [ ! -f "$SOUND_PATH" ]; then
    SOUND_PATH=$(fly-wmfunc FLYWM_SOUND_GET "$1")
  fi
  if [ ! -f "$SOUND_PATH" ]; then
    echo "No sound path found for $1, use full sound file path OR fly-wm sound parameter name for example ForceTrayMessageSound"
    exit 2
  fi
fi

#volume
if [ ! -z "$2" ]; then
  if [[ "$2" == vol=* ]]; then
    tmp="$2"
    SOUND_VOLUME="${tmp:4}"
    if [ "$SOUND_VOLUME" -gt "100" ]; then SOUND_VOLUME="100"; fi
    if [ "$SOUND_VOLUME" -le "0" ]; then SOUND_VOLUME=""; fi
    if [ ! -z "$SOUND_VOLUME" ]; then
      SAVED_VOLUME=`fly-event-volume`
    fi
    SOUND_PLAYER="${@:3}"
  else
    SOUND_PLAYER="${@:2}"
  fi
fi

#player program
if [ -z "$SOUND_PLAYER" ]; then
  if [ -x /usr/bin/play ]; then
   SOUND_PLAYER="/usr/bin/play -q"
  else
   if [ -x /usr/bin/sndfile-play ]; then
     SOUND_PLAYER="/usr/bin/sndfile-play"
   else
     echo "No sound player found"
     exit 3
   fi
  fi
fi


#to use pulse audio system event mixer value
export PULSE_PROP='media.role=event'
if [ ! -z "$SOUND_VOLUME" ]; then
    fly-event-volume "$SOUND_VOLUME"
fi

#echo player command is $SOUND_PLAYER $SOUND_PATH
#echo $SOUND_PLAYER "$SOUND_PATH" volume old=$SAVED_VOLUME new=$SOUND_VOLUME
if [ ! -z "$SOUND_PATH" ]; then
  $SOUND_PLAYER "$SOUND_PATH"
else
  $SOUND_PLAYER
fi

#restore volume
if [ ! -z "$SAVED_VOLUME" ]; then
  fly-event-volume "$SAVED_VOLUME"
fi
