#!/bin/bash

subj=
ddir=

if [ -z "$1" ] || [ "$1" == "$USER" ]; then
subj="$USER"
ddir="$HOME"
else
subj="$1"
ddir=`getent passwd "$1" | cut -f6 -d:`
fi

if [ -z "$LANG" ]; then export LANG="ru_RU.UTF-8"; fi
if [ "$LANG" = "ru_RU.UTF-8" ]; then
  CAPTION="Внимание"
  MESSAGE1="Нет каталога назначения для $subj"
  MESSAGE2="Сбросить настройки Fly для <b>$subj</b> в $ddir и <b>выйти из сессии</b>?"
else
  CAPTION="Attention"
  MESSAGE1="No destination folder for $subj?"
  MESSAGE2="Reset Fly settings for <bt>$subj</b> in $ddir and <b>exit</b>?"
fi

if [ -z "$ddir" ] || [ ! -d "$ddir" ]; then
  if [ ! -z "$DISPLAY" ]; then
     /usr/bin/fly-dialog --caption "$CAPTION" --msgbox "$MESSAGE1"
  fi
     echo "No destination folder $ddir for $subj"
  exit
fi

if [ ! -z "$DISPLAY" ]; then
  /usr/bin/fly-dialog --caption "$CAPTION" --yesno "$MESSAGE2"
  if [ $? == "1" ]; then exit; fi
fi

if [ "$ddir" == "$HOME" ] && [ ! -z "$DISPLAY" ]; then
  fly-wmfunc FLYWM_STOP_WATCH_ALL
fi

cp -f /usr/share/fly-wm/Desktops/Desktop1/.directory $ddir/Desktops/Desktop1
cp -f /usr/share/fly-wm/Desktops/Desktop2/.directory $ddir/Desktops/Desktop2
cp -f /usr/share/fly-wm/Desktops/Desktop3/.directory $ddir/Desktops/Desktop3
cp -f /usr/share/fly-wm/Desktops/Desktop4/.directory $ddir/Desktops/Desktop4
cp -f /usr/share/fly-wm/Desktops/Desktop1/mycomp.desktop  $ddir/Desktops/Desktop1
cp -f /usr/share/fly-wm/Desktops/Desktop1/mytrash.desktop $ddir/Desktops/Desktop1

rm -rf $ddir/.Xresources
rm -rf $ddir/.fly
rm -rf $ddir/.config/fontconfig
rm -rf $ddir/.config/Trolltech.conf
rm -rf $ddir/.config/breezerc
rm -rf $ddir/.config/compton.conf
rm -rf $ddir/.compton

if [ "$ddir" == "$HOME" ]; then
 find `xdg-user-dir PICTURES` -name fly-default* | xargs rm -f
else
 if [ -d $ddir/Pictures ]; then
  find $ddir/Pictures -name fly-default* | xargs rm -f
 fi
 if [ -d $ddir/Изображения ]; then
  find $ddir/Изображения -name fly-default* | xargs rm -f
 fi
fi

if [ "$ddir" == "$HOME" ] && [ ! -z "$DISPLAY" ]; then
#Xorg server will restart after logout
#xrdb -q | sed '/Xcursor.theme/d' | xrdb -load
 fly-wmfunc FLYWM_LOGOUT
fi
